﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Delegates
{
    public delegate string TextFormatterDelegate(string text);

    class Program
    {
        private static string AddStars(string text)
        {
            return "*** " + text + " ***";
        }

        public static string Reverse(string text)
        {
            return new string(text.Reverse().ToArray());
        }

        static void Main(string[] args)
        {
            TextFormatterDelegate textFormatter = new TextFormatterDelegate(AddStars);

            textFormatter += Reverse;

            textFormatter += delegate(string s)
                             {
                                 return s.Remove(4, 4);
                             };

            textFormatter += t => "Lambda " + t;

            string formattedText = textFormatter("Hello World");

            Console.WriteLine(formattedText);
        }

        static void PrintCurrentDate(TextFormatterDelegate formatter)
        {
            string today = DateTime.Now.ToLongDateString();

            string formattedDateTime = formatter(today);

            Console.WriteLine(formattedDateTime);
        }
    }
}
