﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Inheritance
{
    class Program
    {
        public class Base
        {
            public void NonVirtual()
            {
                Console.WriteLine("Base.NonVirtual");
            }

            public virtual void Virtual()
            {
                Console.WriteLine("Base.Virtual");
            }

            public virtual void VirtualWithOverride()
            {
                Console.WriteLine("Base.VirtualWithOverride");
            }

            public virtual void VirtualWithNew()
            {
                Console.WriteLine("Base.VirtualWithNew");
            }
        }

        public class Derived : Base
        {
            public void NonVirtual()
            {
                Console.WriteLine("Derived.NonVirtual");
            }

            public void Virtual()
            {
                Console.WriteLine("Derived.Virtual");
            }

            public override void VirtualWithOverride()
            {
                Console.WriteLine("Derived.VirtualWithOverride");
            }

            public new void VirtualWithNew()
            {
                Console.WriteLine("Derived.VirtualWithNew");
            }
        }

        static void Main(string[] args)
        {
            Base b = new Derived();

            b.NonVirtual();
            b.Virtual();
            b.VirtualWithOverride();
            b.VirtualWithNew();
        }
    }
}
